/*jslint bitwise: true, browser: true, todo: true, evil:true, devel: true, debug: true, nomen: true, plusplus: true, sloppy: true, vars: true, white: true, indent: 2 */
/*globals Engine, API3, deb, print, getAttribType, logObject, logObjectShort, logError, debug */

/*--------------- C H E C K E R -----------------------------------------------

  A bot to checker whetjer the API support game continuation after loading


  tested with 0 A.D. Alpha 15, rev 14923
  V: 0.1, agentx, CGN, Apr, 2014

*/

// prolog
print("---  ### ---  ### ---  ### ---  ### ---  ### ---  ### ---  ### ---  ### ---\n");
Engine.IncludeModule("common-api");

var CHECKER = (function() {

  var C = {API: API3};

  // helper
  C.deb = 5;
  C.toArray = function (a){return Array.prototype.slice.call(a);};
  C.format  = function (){var a=C.toArray(arguments),s=a[0].split("%s"),p=a.slice(1).concat([""]),c=0;return s.map(function(t){return t + p[c++];}).join('');};
  C.attribs = function (o){return Object.keys(o);};
  C.count   = function (o){var attr,cnt=0;for(attr in o){if (o.hasOwnProperty(attr)){cnt+=1;}}return cnt;};

  // constructor
  C.Checker = function(settings) {

    deb();deb();
    deb("------: Checker.constructor.in: PID: %s, difficulty: %s, templates: %s", settings.player, settings.difficulty, C.count(settings.templates));

    API3.BaseAI.call(this, settings);
    this.turn = 0;
    this.id = settings.player;
    this.isTicking = false;
    this.haveTemplates = (settings.templates !== undefined);

    deb();
    deb("------: Checker.constructor.out");
    deb();

  };

  C.Checker.constructor = C.Checker;
  C.Checker.prototype = new C.API.BaseAI();

  C.Checker.prototype.Serialize = function() {

    deb("------: Checker.Serialize.in");
    // return a test object
    var test = {string: "test", number: 2014, array: [1,2,3,4,[5]], object: {stuff: "stuff"}};
    deb("data = " + JSON.stringify(test));
    deb("------: Checker.Serialize.in");
    return test;

  };
  C.Checker.prototype.Deserialize = function(data, sharedScript) {

    deb("------: Checker.Deserialize.in"); deb();
    logObject(this, "this"); deb();
    logObject(data, "data"); deb();
    logObject(sharedScript, "sharedScript"); deb();
    this.isDeserialized = false;
    deb("------: Checker.Deserialize.out");deb();

  };
  C.Checker.prototype.CustomInit = function(gameState, sharedScript) {

    deb("------: Checker.CustomInit.in");
    logObject(this, "this"); deb();
    // logObject(gameState, "gameState"); deb();
    // logObject(sharedScript, "sharedScript"); deb();

    /*
      logObject: this
       *accessibility: OBJECT (width, height, length, maxVal, map, ...)[14]
       *barterPrices: OBJECT (buy, sell, ...)[2]
       *entities: OBJECT (_ai, _entities, _filters, _quickIter, _length, ...)[6]
       *gameState: OBJECT (ai, cellSize, buildingsBuilt, turnCache, sharedScript, ...)[15]
       *passabilityClasses: OBJECT (pathfinderObstruction, foundationObstruction, building-land, building-shore, default, ...)[7]
       *passabilityMap: OBJECT (width, height, data, ...)[3]
       *player: NUMBER (1)
       *playerData: OBJECT (name, civ, colour, popCount, popLimit, ...)[27]
       *sharedScript: OBJECT (_players, _templates, _derivedTemplates, _techTemplates, _entityMetadata, ...)[26]
       *techModifications: OBJECT (structures/athen_civil_centre, units/athen_support_female_citizen, units/athen_support_female_citizen_house, structures/athen_blacksmith, ...)[4]
       *templates: UNDEFINED (undefined)
       *terrainAnalyzer: OBJECT (cellSize, width, height, length, maxVal, ...)[6]
       *territoryMap: OBJECT (width, height, data, ...)[3]
       *timeElapsed: NUMBER (0)
       *turn: NUMBER (0)
      Object.__proto__
        CustomInit: (function (gameState, sharedScript) {"use strict";var SIM_UP
        OnUpdate: (function () {"use strict";var t0 = Date.now(), ctx = this.c
    */

    deb("------: Checker.CustomInit.out");deb();

  };

  C.Checker.prototype.OnUpdate = function(sharedScript) {

    if (!this.isTicking){
      deb("---  ### ---  ### ---  ### ---  ### ---  ### ---  ### ---  ### ---  ### ---");
      deb("------: Checker.OnUpdate.in");
      logObject(this, "this"); deb();
      // logObject(sharedScript, "sharedScript"); deb();
      // logObject(sharedScript[this.id].gameState, "gameState"); deb();
      this.isTicking = true;
    } else {
      deb("------: Checker.OnUpdate.in");
      deb("TICK: #%s", this.turn);
    }

    if (this.events           === undefined){deb("ERROR: events undefined");}
    if (this.gameState        === undefined){deb("ERROR: gameState undefined");}
    if (this.passabilityMap   === undefined){deb("ERROR: passabilityMap undefined");}
    if (this.territoryMap     === undefined){deb("ERROR: territoryMap undefined");}
    if (this.territoryMap     === undefined){deb("ERROR: territoryMap undefined");}
    if (this.entities         === undefined){deb("ERROR: entities undefined");}
    if (this.passabilityMap   === undefined){deb("ERROR: passabilityMap undefined");}
    if (this.passabilityMap   === undefined){deb("ERROR: passabilityMap undefined");}
    if (this.terrainAnalyzer  === undefined){deb("ERROR: terrainAnalyzer undefined");}
    if (this.playerData       === undefined){deb("ERROR: playerData undefined");}
    if (this.terrainAnalyzer  === undefined){deb("ERROR: terrainAnalyzer undefined");}
    if (this.timeElapsed      === undefined){deb("ERROR: timeElapsed undefined");}
    if (this.circularMap      === undefined){deb("ERROR: circularMap undefined");}
    if (this.barterPrices     === undefined){deb("ERROR: barterPrices undefined");}
    if (this.passabilityClasses   === undefined){deb("ERROR: passabilityClasses undefined");}
    if (this.templates === undefined && !this.haveTemplates){deb("ERROR: templates undefined");}

    this.turn++;

    deb("------: Checker.OnUpdate.out");deb();
  };

return C;}());

// global debug helper


function deb(){
  var C = CHECKER,
      args = arguments, al = args.length,
      msg = (
        (al === 0) ? "**" :
        (al === 1) ? args[0] :
          C.format.apply(C, args)
        ) + "\n",
      level = C.deb,
      head = msg.substr(0, 7).toUpperCase();

  if (head === "ERROR :" && level > 0){
    print(msg);
  } else if (head === "WARN  :" && level > 1){
    print(msg);
  } else if (level > 2){
    print(msg);
  } else {
    // do nothing
  }
}


var logObject = function(o, msg){
  var inst = "unidentified";
  msg = msg || "";
  deb();
  deb("Object [%s] : %s  ---------------", inst, msg);
  if (o.constructor){
    deb("Object", getAttribType("constructor", o.constructor));
  }
  logObjectShort(o);
  deb("Object.__proto__");
  logObjectShort(o.__proto__);
  deb("Object.prototype");
  if (o.prototype){
    logObjectShort(o.prototype);
  }
  deb();
};

var logObjectShort = function(o){
  CHECKER.attribs(o).sort().map(function(a){
    return getAttribType(a, o[a]);
  }).forEach(function(line){deb(line);});
};

var getAttribType = function(name, value){

  var C = CHECKER;

  function toString(value){
    return value.toString ? value.toString() : value+"";
  }

  switch (typeof value) {
    case "string":
    case "number":
    case "undefined":
    case "boolean":
      return C.format("  %s: %s (%s)", name, (typeof value).toUpperCase(), value);
    break;
    case "object":
      if (Array.isArray(value)){
        return C.format("  %s: ARRAY [%s](%s, ...)", name, value.length, value.map(toString).slice(0, 5).join(", "));
      } else if (value === null) {
        return C.format("  %s: NULL", name);
      } else {
        return C.format("  %s: OBJECT [%s](%s, ...)", name, C.attribs(value).length, C.attribs(value).slice(0, 5).join(", "));
      }
    break;
    case "function":
      return C.format("  %s: %s", name, value.toSource().split("\n").join("").slice(0, 60));
    break;
  }
  return "WTF";
};